#ifdef WITH_MYSQL

#ifndef __PVPGN_MYSQL_H__
#define __PVPGN_MYSQL_H__

#ifdef WIN32
#include "mysql/config-win.h"
#include "mysql/mysql.h"
#else
#include <mysql/mysql.h>
#endif

#define MYSQL_UID_FIELD "uid"

typedef struct uidlist_struct {
    unsigned int *uids;
    unsigned int len;
} t_uidlist;

typedef struct attrlist_struct {
    char **values, **keys;
    unsigned int len;
} t_attrlist;

extern int db_init();
extern int db_close();
extern int db_check();
extern int db_new_user(char const * name);
extern t_uidlist * db_get_accounts();
extern void db_free_accounts(t_uidlist *);
extern t_attrlist * db_get_attributes(unsigned int);
extern void db_free_attributes(t_attrlist *);
extern int db_set(unsigned int, const char *, const char *);
extern char const * db_get_attribute(unsigned int, char const *);
// aaron - function for getting rid of unwanted columns in tables
extern int db_drop_column(const char *);
// THEUNDYING 8-9-02 Used functions incase Database Doesnt Exist, then make it
extern int dbcreator_start();


#endif /* PVPGN_MYSQL_H */

#endif
