#ifndef __W3XP_PROTOCOL_H__
#define __W3XP_PROTOCOL_H__

#include "common/bnet_protocol.h"

#define CLIENT_W3XP_COUNTRYINFO 0x72ff
#define CLIENT_W3XP_COUNTRYINFO_UNKNOWN1			0x1F450843
#define CLIENT_W3XP_COUNTRYINFO_LANGID_USENGLISH		0x00000409	
#define CLIENT_W3XP_COUNTRYINFO_COUNTRYNAME_USA			"United States"

#define SERVER_W3XP_AUTHREQ 0x72ff

#define CLIENT_W3XP_AUTHREQ	0x04ff
#define SERVER_W3XP_AUTHREPLY	0x04ff

#define SERVER_W3XP_ECHOREQ	0x08ff
#define CLIENT_W3XP_ECHOREPLY	0x08ff

#define CLIENT_W3XP_FILEINFOREQ 0x73ff
#define CLIENT_W3XP_FILEINFOREQ_TYPE_TOS	0x00000001 /* Terms of Service enUS */
#define CLIENT_W3XP_FILEINFOREQ_TYPE_NWACCT	0x00000002 /* New Account File */
#define CLIENT_W3XP_FILEINFOREQ_TYPE_CHTHLP	0x00000003 /* Chat Help */
#define CLIENT_W3XP_FILEINFOREQ_TYPE_SRVLST	0x00000005 /* Server List */
#define CLIENT_W3XP_FILEINFOREQ_UNKNOWN1	0x00000000
#define CLIENT_W3XP_FILEINFOREQ__FILE_TOSUSA	"termsofservice-enUS.txt"
#define CLIENT_W3XP_FILEINFOREQ__FILE_NWACCT	"newaccount-enUS.txt"
#define CLIENT_W3XP_FILEINFOREQ__FILE_CHTHLP	"chathelp-war3-enUS.txt"
#define CLIENT_W3XP_FILEINFOREQ__FILE_SRVLST	"bnserver-WAR3.ini"
#define SERVER_W3XP_FILEINFOREPLY	0x73ff

#define CLIENT_W3XP_ICONREQ	0x45ff
#define SERVER_W3XP_ICONREPLY	0x45ff

#define CLIENT_W3XP_LOGINREQ 0x43ff
#define SERVER_W3XP_LOGINREPLY	0x43ff

#define CLIENT_W3XP_LOGONPROOFREQ 0x12ff
#define SERVER_W3XP_LOGONPROOFREPLY	0x12ff

#define CLIENT_W3XP_CHANGEGAMEPORT	0x5aff

#define CLIENT_W3XP_PLAYERINFOREQ	0x7fff
#define SERVER_W3XP_PLAYERINFOREPLY	0x7fff

#define CLIENT_W3XP_MOTD		0x36ff
#define SERVER_W3XP_MOTD	0x36ff

#define CLIENT_W3XP_JOINCHANNEL	0x71ff

#define SERVER_W3XP_MESSAGE	0x59ff
#define CLIENT_W3XP_STATSREQ	0x16ff
#define SERVER_W3XP_STATSREPLY	0x16ff

#define CLIENT_W3XP_CREATEACCOUNT	0x07ff
#define SERVER_W3XP_CREATEACCOUNT	0x07ff

#define CLIENT_W3XP_GAMELISTREQ		0x68FF
#define SERVER_W3XP_GAMELISTREPLY	0x68FF

#define CLIENT_W3XP_STARTGAME		0x79ff

#define CLIENT_W3XP_JOIN_GAME		0x4AFF

/*
*/
// #define CLIENT_W3XP_GAMERESULT		0x37ff

//#define CLIENT_W3XP_CLOSEGAME		0x67FF

#define CLIENT_W3XP_MESSAGE		0x0aff

#define SERVER_W3XP_FRIENDADD_ACK	0x0bff

#define CLIENT_W3XP_FRIENDSLIST_REQ	0x33ff

#define SERVER_W3XP_FRIENDSLIST_REPLY	0x33ff

#define	SERVER_W3XP_FRIENDDEL_ACK	0x3fff

#define	CLIENT_W3XP_FRIENDINFO_REQ	0x20ff

#define	SERVER_W3XP_FRIENDINFO_REPLY	0x20ff

#define CLIENT_W3XP_ANONGAME_REQ	0x34ff

#define SERVER_W3XP_ANONGAME_REPLY	0x34ff

#define CLIENT_W3XP_ADREQ		0x42ff

#define SERVER_W3XP_ADREPLY		0x42ff


/* W3 ROUTE packets */

#define CLIENT_W3XP_W3ROUTE_REQ		0x1EF7

// #define SERVER_W3XP_W3ROUTE_ECHOREQ	0x46F7

#define SERVER_W3XP_W3ROUTE_PLAYERINFO	0x23f7

#define CLIENT_W3XP_W3ROUTE_GAMERESULT	0x2ef7

#define CLIENT_W3XP_CHANLISTREQ		0x62ff
#define SERVER_W3XP_CHANLISTREPLY	0x62ff

// arranged team handling

#define CLIENT_W3XP_ARRANGEDTEAM_FRIENDSCREEN 0x2eff

#define SERVER_W3XP_ARRANGEDTEAM_FRIENDSCREEN 0x2eff

// clan handling

/*
12: recv class=bnet[0x02] type=unknown[0x7dff] length=12
0000:   FF 7D 0C 00 01 00 00 00   49 65 68 54                .}......IehT  
*/

#define CLIENT_W3XP_CLAN_INFOREQ 0x7dff
typedef struct{
  t_bnet_header        h;
  bn_int               count;
  bn_int               clanshort;
} t_client_w3xp_clan_inforeq PACKED_ATTR();

#define SERVER_W3XP_CLAN_INFOREPLY 0x7dff
typedef struct{
  t_bnet_header        h;
  bn_int               count;
  bn_short             message;
} t_server_w3xp_clan_inforeply PACKED_ATTR();

#define SERVER_W3XP_CLAN_INFOREPLY_MESSAGE_OK 0x0000
#define SERVER_W3XP_CLAN_INFOREPLY_MESSAGE_ALLREADY_IN_USE 0x0001

#endif
