#include "../common/setup_before.h"
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include "../common/hexdump.h"
#include "../common/setup_after.h"

typedef struct dump_header_struct {
   unsigned long type, timestamp, size;
} t_dump_header;

int main(int argc, char **argv)
{
   char *fname = "packet.log";
   int hdr=0;
   t_dump_header header;
   char packet[65536], serverheader[4];
   FILE *f;
   
   if(argc == 2)
     fname = argv[1];
   f = fopen(fname, "rb");
   if(!f)
     return 1;
   
   for(;;) {
      if(!fread(&header, 3 * sizeof(unsigned long), 1, f))
	break;
      
      if(!header.size || header.size>65000) {
	 printf("invalid size: %lu\n", header.size);
	 break;
      }
      
      if(!fread(packet+4, header.size, 1, f))
	break;
      
      switch(header.type)
	{
	 case 0:
	   if(hdr)
	     break;
	   printf("---\ntime %lu\tsize %lu\ttype: 0x%04X\tto server\n", header.timestamp, header.size, (header.size >= 4) ? *((unsigned short *)(packet + 4)) : 0);
	   hexdump(stdout, packet+4, header.size);
	 case 1:
	   if(!hdr)
	     break;
	   memcpy(packet,serverheader,4);
	   printf("---\ntime %lu\tsize %lu\ttype: 0x%04X\tfrom server\n", header.timestamp, header.size+4, *((unsigned short *)packet));
	   hexdump(stdout, packet, header.size+4);
	   hdr=0;
	   break;
	 case 2:
	   printf("---\ntime %lu\tsize %lu\ttype: 0x%04X\tunencrypted/unknown\n", header.timestamp, header.size, (header.size >= 4) ? *((unsigned short *)(packet + 4)) : 0);
	   hexdump(stdout, packet+4, header.size);
	   break;
	 case 3:
	   hdr=1;
	   memcpy(serverheader,packet+4,4);
	   break;
	 default:
	   printf("packet log is corrupt\n");
	   return 2;
	}
   }
   return 0;
}
